package Helpers;

public class Crypter {
	private static final String KEY = "%*#?";
	
	
	public static String crypt(String phrase) {
		String key = KEY;
		String sCrypted = "";
		// autokey:
		if (key.length() < phrase.length()) {
			key += phrase.substring(0, phrase.length() - key.length());
		}

		int iStart = 33; // !, erstes druckbares zeichen ausser ' ', welches durch trim() verloren gehen knnte
		int iEnd = 126; // ~, letztes druckbares standard-ascii-zeichen
		
		// chars durchgehen
		for (int i = 0; i < phrase.length(); i++){
			/* erg = key + (phrase - Start)
			   wenn erg > end
				   erg = start + (erg - end) - 1*/
	    	char cPhrase = phrase.charAt(i);
	    	char cKey =    key.charAt(i);
	    	int iErg = cKey + (cPhrase - iStart);
	    	if (iErg > iEnd) iErg = iStart + (iErg - iEnd) - 1;
	    	sCrypted += (char)iErg;
	    }
		
		return sCrypted;
	}
	
	public static String decrypt(String crypt) {
		String key = KEY;
		String sEncrypted = "";

		int iStart = 33; // !, erstes druckbares zeichen ausser ' ', welches durch trim() verloren gehen knnte
		int iEnd = 126; // ~, letztes druckbares standard-ascii-zeichen
		
		// chars durchgehen
		for (int i = 0; i < crypt.length(); i++){			
	    	char cCrypted = crypt.charAt(i);
	    	char cKey;
	    	if (key.length() > i) {
	    		cKey = key.charAt(i);
	    	} else {
	    		cKey = sEncrypted.charAt(i - key.length());
	    	}
	    	
	    	/*wenn crypt > key
	    	 	erg = (crypt - key) + start
			else
				erg = end + (crypt - start) - key + start + 1*/
	    	int iErg = 0;
	    	if (cCrypted > cKey) {
	    		iErg = (cCrypted - cKey) + iStart;
	    	} else {
	    		iErg = (iEnd + (cCrypted - iStart)) - cKey + iStart + 1;
	    	}
	    	sEncrypted += (char)iErg;
	    }
		
		return sEncrypted;
	}
}
